local M = {}



function M.calcular_distancia(pos1, pos2)

    local dx = pos2.x - pos1.x
    local dy = pos2.y - pos1.y

    distancia = math.sqrt(dx^2 + dy^2)

    return distancia

end



function M.add_hostile_units(n, pos_libres, pos_unidades)

    local hostile_fourcc = list('nftr', 'nspg', 'nogr')

    local unidades_hostiles = list() -- {}

    while #unidades_hostiles < n do

        --print(#unidades_hostiles)

        local index = math.random(1, #pos_libres)

        local pos = pos_libres[index]

        
        local descartar = false

        for index , p in ipairs(pos_unidades) do
            local distancia = M.calcular_distancia(p, pos)
            --print(distancia)
            if distancia < 600 then
                descartar = true
                break
            end
        end


        if descartar == false then

            local fourcc_str = hostile_fourcc[math.random(1, #hostile_fourcc)]

            local unit = create_unit(playerlist[15], FourCC(fourcc_str), pos.x, pos.y, math.random(0, 360)) -- PLAYER_NEUTRAL_AGGRESSIVE en lugar de Player(15) funciona pero muestra ubicaciones en el minimapa

            unit.origin_pos = pos

            unit.event(EVENT_UNIT_DAMAGED, function(e)

                DestroyTrigger(GetTriggeringTrigger()) -- que no se ejecute de nuevo al aplicar daño a continuación...
                e.unit.set_state(UNIT_STATE_LIFE, 0)
                --UnitDamageTarget(GetEventDamageSource(), e.unit.target, e.unit.get_state(UNIT_STATE_MAX_LIFE), true, false, ATTACK_TYPE_NORMAL, nil, WEAPON_TYPE_WHOKNOWS)

                --hay que hacer esto porque al eliminar con el indice que conozco cambia el indice del resto...
                for _index, _unit in ipairs(unidades_hostiles) do
                    if _unit == unit then
                        unidades_hostiles.pop(_index) -- table.remove(unidades_hostiles, _index)
                        break
                    end
                end

                if #unidades_hostiles == 0 then
                    DisplayTextToPlayer(Player(0), 0, 0, 'Victoria!!')
                    TimerEvent(5, false, function(e)
                        EndGame(Player(0))
                    end)
                end


            end)

            table.remove(pos_libres, index)

            pos_unidades.append(pos) -- pos_unidades[#pos_unidades+1] = pos
            unidades_hostiles.append(unit) -- unidades_hostiles[#unidades_hostiles+1] = unit

        end

    end


    TimerEvent(0.5, true, function(e)
    
        for _, unit in ipairs(unidades_hostiles) do

            local current_pos = {x=unit.get_x(), y=unit.get_y()}

            if M.calcular_distancia(current_pos, unit.origin_pos) >= 400 then
                --unit.issue_immediate_order('stop')
                --unit.issue_immediate_order('turn180')
                unit.issue_point_order('move', unit.origin_pos.x, unit.origin_pos.y)
            end

        end
    
    end)



    return unidades_hostiles


end



return M