require('custom.pythonic')
require('custom.ezmode')

require('settings.delete_all_units')
require('settings.settings')

local playable = require('playable')
local hostiles = require('hostiles')

local posiciones_libres = list()



local function create_destructable(x, y)

    local w = Table()

    local fourcc_list = list('LTlt', 'FTtw', 'LTrt', 'LTrc', 'LOcg', 'LTex')

    local random_fourcc = fourcc_list[math.random(1, #fourcc_list)]

    local destructable_id = FourCC(random_fourcc)
    local facing = 0
    local scale = 1
    local variation = 0

    return CreateDestructable(destructable_id, x, y, facing, scale, variation)

end








TimerEvent(0, false, function(e)

    
    local all_rect = GetEntireMapRect()
    local map_rect = GetPlayableMapRect() -- x (izquierda -, derecha +) | y (arriba +, abajo -)

    local start_x, start_y = GetRectMinX(all_rect), GetRectMinY(all_rect)
    local end_x, end_y = GetRectMaxX(all_rect), GetRectMaxY(all_rect)
    local spacing = 128



    local destructables = Table()
    local posiciones_iniciales = Table()

    for x = start_x, end_x, spacing do

        for y = start_y, end_y, spacing do

            local key = tostring(x) .. ',' .. tostring(y)

            destructables[key] = create_destructable(x, y)

        end

    end




    local function crear_path_vertical()

        local pos_inicial = (function()
    
            local options = list()
    
            for x = GetRectMinX(map_rect), GetRectMaxX(map_rect), spacing do
    
                options.append({x=x, y=GetRectMaxY(map_rect)}) -- table.insert(options, {x=x, y=GetRectMaxY(map_rect)})
    
            end
    
            return options[math.random(1, #options)]
    
        end)()
    
    
        local current_x = pos_inicial.x
        local current_y = pos_inicial.y
    
        local key = tostring(current_x) .. ',' .. tostring(current_y)
        local destructable = destructables[key]
        RemoveDestructable(destructable)
    
        local current_y = current_y - spacing
    
        local key = tostring(current_x) .. ',' .. tostring(current_y)
        local destructable = destructables[key]
        RemoveDestructable(destructable)
    
    
    
    
        local last_path = 'down'
    
    
        while true do
    
            local x_limit_left = current_x - (spacing*2)
            local x_limit_right = current_x + (spacing*2)
    
            if x_limit_left <= GetRectMinX(map_rect) then
                
                if math.random(1, 2) == 1 then
                    last_path = 'down'
                else
                    last_path = 'right'
                end
                
            elseif x_limit_right >= GetRectMaxX(map_rect) then
    
                if math.random(1, 2) == 1 then
                    last_path = 'down'
                else
                    last_path = 'left'
                end
    
            elseif last_path == 'down' then
    
                if math.random(1, 2) == 1 then
                    last_path = 'left'
                else 
                    last_path = 'right'
                end
    
            elseif math.random(1, 2) == 1 then
                    last_path = 'down'
            end
    
    
            local to_remove = Table()
    
            for i = 1, 2 do
    
                if last_path == 'down' then
                    current_y = current_y - spacing
                elseif last_path == 'left' then
                    current_x = current_x - spacing
                elseif last_path == 'right' then
                    current_x = current_x + spacing
                else
                    print('INESPERADO: last_path =', last_path)
                end
    
    
                local key = tostring(current_x) .. ',' .. tostring(current_y)
    
                local destructable = destructables[key]
    
                --print(destructable, current_x, current_y)
    
                table.insert(to_remove, destructable)
    
            end
    
    
    
            for _, destructable in pairs(to_remove) do
    
                if destructable ~= nil then

                    local pos_libre = {
                        x=GetDestructableX(destructable),
                        y=GetDestructableY(destructable)
                    }

                    posiciones_libres.append(pos_libre) --table.insert(posiciones_libres, {x=GetDestructableX(destructable), y=GetDestructableY(destructable)})
                    RemoveDestructable(destructable)

                end
    
            end
    
    
            if current_y <= GetRectMinY(map_rect) then
                --DestroyTimer(timer)
                break
            end
    
    
        end
    
    
    end
    
    
    local function crear_path_horizontal()
    
        local pos_inicial = (function()
    
            local options = Table()
    
            for y = GetRectMinY(map_rect), GetRectMaxY(map_rect), spacing do
    
                table.insert(options, {x=GetRectMinX(map_rect), y=y})
    
            end
    
            return options[math.random(1, #options)]
    
        end)()
    
    
        local current_x = pos_inicial.x
        local current_y = pos_inicial.y
    
        local key = tostring(current_x) .. ',' .. tostring(current_y)
        local destructable = destructables[key]
        RemoveDestructable(destructable)
    
        local current_x = current_x + spacing
    
        local key = tostring(current_x) .. ',' .. tostring(current_y)
        local destructable = destructables[key]
        RemoveDestructable(destructable)
    
    
    
    
        local last_path = 'right'
    
    
        while true do
    
            local y_limit_up = current_y + (spacing*2)
            local y_limit_down = current_y - (spacing*2)
    
            if y_limit_up >= GetRectMaxY(map_rect) then
                
                if math.random(1, 2) == 1 then
                    last_path = 'right'
                else
                    last_path = 'down'
                end
                
            elseif y_limit_down <= GetRectMinY(map_rect) then
    
                if math.random(1, 2) == 1 then
                    last_path = 'right'
                else
                    last_path = 'up'
                end
    
            elseif last_path == 'right' then
    
                if math.random(1, 2) == 1 then
                    last_path = 'up'
                else 
                    last_path = 'down'
                end
    
            elseif math.random(1, 2) == 1 then
                    last_path = 'right'
            end
    
    
            local to_remove = list()
    
            for i = 1, 2 do
    
                if last_path == 'down' then
                    current_y = current_y - spacing
                elseif last_path == 'up' then
                    current_y = current_y + spacing
                elseif last_path == 'right' then
                    current_x = current_x + spacing
                else
                    print('INESPERADO: last_path =', last_path)
                end
    
    
                local key = tostring(current_x) .. ',' .. tostring(current_y)
    
                local destructable = destructables[key]
    
                --print(destructable, current_x, current_y)
    
                to_remove.append(destructable) --table.insert(to_remove, destructable)
    
            end
    
    
    
            for _, destructable in ipairs(to_remove) do
    
                if destructable ~= nil then

                    local pos_libre = {
                        x=GetDestructableX(destructable),
                        y=GetDestructableY(destructable)
                    }

                    posiciones_libres.append(pos_libre) --table.insert(posiciones_libres, {x=GetDestructableX(destructable), y=GetDestructableY(destructable)})
                    RemoveDestructable(destructable)

                end
    
            end
    
    
            if current_x >= GetRectMaxX(map_rect) then
                --DestroyTimer(timer)
                break
            end
    
    
        end
    
    
    end



    local n_caminos = 2
    local n_unidades_hostiles = 6

    if false then
        n_caminos = 3 --5
        n_unidades_hostiles = 12 --250
    end

    for i = 1, n_caminos do
        crear_path_vertical()
    end

    for i = 1, n_caminos do
        crear_path_horizontal()
    end



    local unit = playable.add_playable_unit(posiciones_libres)

    local posiciones_unidades = list({x=unit.get_x(), y=unit.get_y()})

    local unidades_hostiles = hostiles.add_hostile_units(n_unidades_hostiles, posiciones_libres, posiciones_unidades)



    local new_radar_rect = function()

        local unit_x, unit_y = unit.get_x(), unit.get_y()

        local x1, y1 = unit_x - 1000, unit_y + 1000
        local x2, y2 = unit_x + 1000, unit_y - 1000

        local rect = Rect(x1, y1, x2, y2)

        return rect

    end

    TimerEvent(0.1, true, function(e)

        local barriles = list()

        local radar_rect = new_radar_rect()

        EnumDestructablesInRect(radar_rect, nil, function()
            local destructable = GetEnumDestructable()
            if reverseFourCC(GetDestructableTypeId(destructable)) == 'LTex' then
                barriles.append(destructable)
            end
        end)

    
        for index, barril in ipairs(barriles) do

            local vida_barril = GetDestructableLife(barril)

            if vida_barril == 0 then

                local group = CreateGroup()

                GroupEnumUnitsInRect(group, radar_rect, nil)

                local unidades_hostiles_detectadas = list()

                ForGroup(group, function()
                    local unit_detected = GetEnumUnit()
                    if GetOwningPlayer(unit_detected) ~= Player(0) then
                        unidades_hostiles_detectadas.append(mk_wrap_table(unit_detected, 'Unit'))
                    end
                end)

                DestroyGroup(group)

                for index, u_hostil in ipairs(unidades_hostiles_detectadas) do

                    local distancia = DistanceBetweenPoints(Location(u_hostil.get_x(), u_hostil.get_y()), Location(GetDestructableX(barril), GetDestructableY(barril)))

                    if distancia <= 250 then
                        u_hostil.set_state(UNIT_STATE_LIFE, 0)
                    end

                    TimerEvent(0.1, false, function(e)
                        RemoveDestructable(barril)
                    end)

                end

                break -- no comprobar mas barriles y salir

            end

        end

        
        RemoveRect(radar_rect)
    
    
    end)




end)